<?php
/*
http://www.payline.com

Payline module for OpenCart - v1.3 - January 2014

Copyright (c) 2014 Monext
*/
require_once(DIR_SYSTEM.'payline/configuration/options.php');
require_once(DIR_SYSTEM.'payline/lib/paylineSDK.php');

class ControllerPaymentPayline extends Controller {
	
	var $paylineTrace;
	
	private $error = array();
	private $basicsettingsok;
	private $posData;
	
	/**
	 * @method index
	 * @desc Initialize and display Payline configuration form
	 */
	public function index() {
		$this->load->language('payment/payline');
		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('setting/setting');
		
		$currentPrimaryContrats = $this->config->get('payline_primary_contracts');
		
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('payline', $this->request->post);
			if($currentPrimaryContrats == null){
				$this->session->data['success'] = $this->language->get('text_incomplete');
			} else {
				$this->session->data['success'] = $this->language->get('text_success');
			}
			$this->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
		}
		
		/*
		 * labels and fieldsets
		 */
		$this->data['heading_title']					= $this->language->get('heading_title');
		$this->data['text_enabled']						= $this->language->get('text_enabled');
		$this->data['text_disabled']					= $this->language->get('text_disabled');
		$this->data['text_production']					= $this->language->get('text_production');
		$this->data['text_homologation']				= $this->language->get('text_homologation');
		$this->data['text_all_zones']					= $this->language->get('text_all_zones');
		$this->data['payment_action_101']				= $this->language->get('payment_action_101');
		$this->data['payment_action_100']				= $this->language->get('payment_action_100');
		$this->data['fieldset_payline_module']			= $this->language->get('fieldset_payline_module');
		$this->data['fieldset_payline_auth']			= $this->language->get('fieldset_payline_auth');
		$this->data['fieldset_payline_proxy']			= $this->language->get('fieldset_payline_proxy');
		$this->data['fieldset_payline_payment']			= $this->language->get('fieldset_payline_payment');
		$this->data['fieldset_payline_contracts']		= $this->language->get('fieldset_payline_contracts');
		$this->data['fieldset_payline_basicsettings']	= $this->language->get('fieldset_payline_basicsettings');
		
		/*
		 * Module settings
		 */
		$this->data['entry_payline_status']	= $this->language->get('entry_payline_status');
		$this->data['entry_geo_zone']		= $this->language->get('entry_geo_zone');
		$this->data['entry_sort_order']		= $this->language->get('entry_sort_order');
		$this->data['entry_method_name']	= $this->language->get('entry_method_name');
		$this->data['help_method_name']		= $this->language->get('help_method_name');
		$this->data['help_payline_status']	= $this->language->get('help_payline_status');
		$this->data['help_geo_zone']		= $this->language->get('help_geo_zone');
		$this->data['help_sort_order']		= $this->language->get('help_sort_order');
		if (isset($this->request->post['payline_status'])) {
			$this->data['payline_status'] = $this->request->post['payline_status'];
		} else {
			$this->data['payline_status'] = $this->config->get('payline_status');
		}
		$this->load->model('localisation/geo_zone');
		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		if (isset($this->request->post['payline_geo_zone_id'])) {
			$this->data['payline_geo_zone_id'] = $this->request->post['payline_geo_zone_id'];
		} else {
			$this->data['payline_geo_zone_id'] = $this->config->get('payline_geo_zone_id');
		}
		if (isset($this->request->post['payline_sort_order'])) {
			$this->data['payline_sort_order'] = $this->request->post['payline_sort_order'];
		} else {
			$this->data['payline_sort_order'] = $this->config->get('payline_sort_order');
		}
		if (isset($this->request->post['payline_method_name'])) {
			$this->data['payline_method_name'] = $this->request->post['payline_method_name'];
		} else {
			$this->data['payline_method_name'] = $this->config->get('payline_method_name');
		}
		if (isset($this->error['method_name'])) {
			$this->data['error_method_name'] = $this->error['method_name'];
		} else {
			$this->data['error_method_name'] = '';
		}
		
		/*
		 * Payline connection 
		 */
		$this->data['entry_environment']	= $this->language->get('entry_environment');
		$this->data['entry_merchant_id']	= $this->language->get('entry_merchant_id');
		$this->data['entry_access_key']		= $this->language->get('entry_access_key');
		$this->data['help_environment']		= $this->language->get('help_environment');
		$this->data['help_merchant_id']		= $this->language->get('help_merchant_id');
		$this->data['help_access_key']		= $this->language->get('help_access_key');
		if (isset($this->error['environment'])) {
			$this->data['error_environment'] = $this->error['environment'];
		} else {
			$this->data['error_environment'] = '';
		}
		if (isset($this->error['merchant_id'])) {
			$this->data['error_merchant_id'] = $this->error['merchant_id'];
		} else {
			$this->data['error_merchant_id'] = '';
		}
		if (isset($this->error['access_key'])) {
			$this->data['error_access_key'] = $this->error['access_key'];
		} else {
			$this->data['error_access_key'] = '';
		}
		if (isset($this->request->post['production'])) {
			$this->data['production'] = $this->request->post['production'];
		} else {
			$this->data['production'] = $this->config->get('production');
		}
		if (isset($this->request->post['payline_merchant_id'])) {
			$this->data['payline_merchant_id'] = $this->request->post['payline_merchant_id'];
		} else {
			$this->data['payline_merchant_id'] = $this->config->get('payline_merchant_id');
		}
		if (isset($this->request->post['payline_access_key'])) {
			$this->data['payline_access_key'] = $this->request->post['payline_access_key'];
		} else {
			$this->data['payline_access_key'] = $this->config->get('payline_access_key');
		}
		
		/*
		 * Contracts
		 */
		$this->data['payline_basicsettingsok']	= $this->config->get('payline_basicsettingsok');
		$this->data['payline_posData']			= $this->config->get('payline_posData');
		$this->data['entry_select_pos']			= $this->language->get('entry_select_pos');
		if($currentPrimaryContrats == null){
			$this->data['error_primary_contracts'] = $this->language->get('required_primary_contracts');
		} else {
			$this->data['error_primary_contracts'] = '';
		}
		
		/*
		 * Payment settings
		 */
		$this->data['entry_payment_action']	= $this->language->get('entry_payment_action');
		$this->data['help_payment_action']	= $this->language->get('help_payment_action');
		if (isset($this->request->post['payment_action'])) {
			$this->data['payment_action'] = $this->request->post['payment_action'];
		} else {
			$this->data['payment_action'] = $this->config->get('payment_action');
		}
		
		/*
		 * Order statuses
		 */
		$this->data['entry_init_status']		= $this->language->get('entry_init_status');
		$this->data['entry_accepted_status']	= $this->language->get('entry_accepted_status');
		$this->data['entry_canceled_status']	= $this->language->get('entry_canceled_status');
		$this->data['entry_refused_status']     = $this->language->get('entry_refused_status');
		$this->data['entry_abandoned_status']   = $this->language->get('entry_abandoned_status');
		$this->data['help_init_status']			= $this->language->get('help_init_status');
		$this->data['help_accepted_status']		= $this->language->get('help_accepted_status');
		$this->data['help_canceled_status']		= $this->language->get('help_canceled_status');
		$this->data['help_refused_status']		= $this->language->get('help_refused_status');
		$this->data['help_abandoned_status']	= $this->language->get('help_abandoned_status');
		$this->load->model('localisation/order_status');
		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		if (isset($this->request->post['init_status_id'])) {
			$this->data['init_status_id'] = $this->request->post['init_status_id'];
		} else {
			$this->data['init_status_id'] = $this->config->get('init_status_id');
		}
		if (isset($this->request->post['accepted_status_id'])) {
			$this->data['accepted_status_id'] = $this->request->post['accepted_status_id'];
		} else {
			$this->data['accepted_status_id'] = $this->config->get('accepted_status_id');
		}
		if (isset($this->request->post['canceled_status_id'])) {
			$this->data['canceled_status_id'] = $this->request->post['canceled_status_id'];
		} else {
			$this->data['canceled_status_id'] = $this->config->get('canceled_status_id');
		}
		if (isset($this->request->post['refused_status_id'])) {
			$this->data['refused_status_id'] = $this->request->post['refused_status_id'];
		} else {
			$this->data['refused_status_id'] = $this->config->get('refused_status_id');
		}
		if (isset($this->request->post['abandoned_status_id'])) {
			$this->data['abandoned_status_id'] = $this->request->post['abandoned_status_id'];
		} else {
			$this->data['abandoned_status_id'] = $this->config->get('abandoned_status_id');
		}
		
		/*
		 * web page customization
		 */
		$this->data['entry_template_url']		= $this->language->get('entry_template_url');
		$this->data['entry_custom_page_code']	= $this->language->get('entry_custom_page_code');
		$this->data['help_template_url']		= $this->language->get('help_template_url');
		$this->data['help_custom_page_code']	= $this->language->get('help_custom_page_code');
		if (isset($this->request->post['template_url'])) {
			$this->data['template_url'] = $this->request->post['template_url'];
		} else {
			$this->data['template_url'] = $this->config->get('template_url');
		}
		if (isset($this->request->post['custom_page_code'])) {
			$this->data['custom_page_code'] = $this->request->post['custom_page_code'];
		} else {
			$this->data['custom_page_code'] = $this->config->get('custom_page_code');
		}
		
		/*
		 * Proxy settings
		 */
		$this->data['entry_proxy_host']		= $this->language->get('entry_proxy_host');
		$this->data['entry_proxy_port']		= $this->language->get('entry_proxy_port');
		$this->data['entry_proxy_login']	= $this->language->get('entry_proxy_login');
		$this->data['entry_proxy_password']	= $this->language->get('entry_proxy_password');
		$this->data['help_proxy_host']		= $this->language->get('help_proxy_host');
		$this->data['help_proxy_port']		= $this->language->get('help_proxy_port');
		$this->data['help_proxy_login']		= $this->language->get('help_proxy_login');
		$this->data['help_proxy_password']	= $this->language->get('help_proxy_password');
		if (isset($this->error['proxy'])) {
			$this->data['error_proxy'] = $this->error['proxy'];
		} else {
			$this->data['error_proxy'] = '';
		}
		if (isset($this->request->post['proxy_host'])) {
			$this->data['proxy_host'] = $this->request->post['proxy_host'];
		} else {
			$this->data['proxy_host'] = $this->config->get('proxy_host');
		}
		if (isset($this->request->post['proxy_port'])) {
			$this->data['proxy_port'] = $this->request->post['proxy_port'];
		} else {
			$this->data['proxy_port'] = $this->config->get('proxy_port');
		}
		if (isset($this->request->post['proxy_login'])) {
			$this->data['proxy_login'] = $this->request->post['proxy_login'];
		} else {
			$this->data['proxy_login'] = $this->config->get('proxy_login');
		}
		if (isset($this->request->post['proxy_password'])) {
			$this->data['proxy_password'] = $this->request->post['proxy_password'];
		} else {
			$this->data['proxy_password'] = $this->config->get('proxy_password');
		}
				
		/*
		 * Buttons
		 */
		$this->data['button_save']		= $this->language->get('button_save');
		$this->data['button_cancel']	= $this->language->get('button_cancel');
		
		
		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}
		
		/*
		 * Navigation
		 */
		$this->data['breadcrumbs'] = array();
		$this->data['breadcrumbs'][] = array(
		       		'text'      => $this->language->get('text_home'),
					'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
		      		'separator' => false
		);
		$this->data['breadcrumbs'][] = array(
		       		'text'      => $this->language->get('text_payment'),
					'href'      => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'),      		
		      		'separator' => ' :: '
		);
		$this->data['breadcrumbs'][] = array(
		       		'text'      => $this->language->get('heading_title'),
					'href'      => $this->url->link('payment/payline', 'token=' . $this->session->data['token'], 'SSL'),
		      		'separator' => ' :: '
		);
		
		$this->data['action'] = $this->url->link('payment/payline', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');
		
		$this->template = 'payment/payline.tpl';
		$this->children = array(
					'common/header',
					'common/footer'
		);
		
		$this->response->setOutput($this->render());
	}
	
	private function addPOSFromObject($oPointOfSell,$pos){
		if(isset($oPointOfSell->contracts->contract)){
			$this->posData[$pos] = array();
			$this->posData[$pos]['label'] = $oPointOfSell->label;
			$this->posData[$pos]['used'] = 0;
			$this->posData[$pos]['contracts'] = array();
			if(sizeof($oPointOfSell->contracts->contract) > 1){
				// more than 1 active contract in this point of sell
				$ctr = 0;
				foreach ($oPointOfSell->contracts->contract as $contract){
					$this->posData[$pos]['contracts'][$ctr] = array();
					$this->posData[$pos]['contracts'][$ctr]['cardType'] = $contract->cardType;
					$this->posData[$pos]['contracts'][$ctr]['logo'] = $this->getLogo($contract->cardType);
					$this->posData[$pos]['contracts'][$ctr]['label'] = $contract->label;
					$this->posData[$pos]['contracts'][$ctr]['contractNumber'] = $contract->contractNumber;
					$this->posData[$pos]['contracts'][$ctr]['primary'] = 0;
					$this->posData[$pos]['contracts'][$ctr]['secondary'] = 0;
					$ctr++;
				}
			}else{ // only 1 active contract in this point of sell
				$this->posData[$pos]['contracts'][0] = array();
				$this->posData[$pos]['contracts'][0]['cardType'] = $oPointOfSell->contracts->contract->cardType;
				$this->posData[$pos]['contracts'][0]['logo'] = $this->getLogo($oPointOfSell->contracts->contract->cardType);
				$this->posData[$pos]['contracts'][0]['label'] = $oPointOfSell->contracts->contract->label;
				$this->posData[$pos]['contracts'][0]['contractNumber'] = $oPointOfSell->contracts->contract->contractNumber;
				$this->posData[$pos]['contracts'][0]['primary'] = 0;
				$this->posData[$pos]['contracts'][0]['secondary'] = 0;
			}
		}else{ // no contract in this point of sell
			return false;
		}
		
		return true;
	}
	
	private function addPOSFromArray($aPointOfSell,$pos){
		if(isset($aPointOfSell['contracts']['contract'])){
			$this->posData[$pos] = array();
			$this->posData[$pos]['label'] = $aPointOfSell['label'];
			$this->posData[$pos]['used'] = 0;
			$this->posData[$pos]['contracts'] = array();
			if(isset($aPointOfSell['contracts']['contract']['label'])){
				// only 1 active contract in this point of sell
				$this->posData[$pos]['contracts'][0] = array();
				$this->posData[$pos]['contracts'][0]['cardType'] = $aPointOfSell['contracts']['contract']['cardType'];
				$this->posData[$pos]['contracts'][0]['logo'] = $this->getLogo($aPointOfSell['contracts']['contract']['cardType']);
				$this->posData[$pos]['contracts'][0]['label'] = $aPointOfSell['contracts']['contract']['label'];
				$this->posData[$pos]['contracts'][0]['contractNumber'] = $aPointOfSell['contracts']['contract']['contractNumber'];
				$this->posData[$pos]['contracts'][0]['primary'] = 0;
				$this->posData[$pos]['contracts'][0]['secondary'] = 0;
			}else{ // more than 1 active contract in this point of sell
				$ctr = 0;
				foreach ($aPointOfSell['contracts']['contract'] as $contract){
					$this->posData[$pos]['contracts'][$ctr] = array();
					$this->posData[$pos]['contracts'][$ctr]['cardType'] = $contract->cardType;
					$this->posData[$pos]['contracts'][$ctr]['logo'] = $this->getLogo($contract->cardType);
					$this->posData[$pos]['contracts'][$ctr]['label'] = $contract->label;
					$this->posData[$pos]['contracts'][$ctr]['contractNumber'] = $contract->contractNumber;
					$this->posData[$pos]['contracts'][$ctr]['primary'] = 0;
					$this->posData[$pos]['contracts'][$ctr]['secondary'] = 0;
					$ctr++;
				}
			}
		}else{ // no contract in this point of sell
			return false;
		}
		return true;
	}
	
	private function merchantSettingsToPosData($getMerchantSettingsResponse){
		if(isset($getMerchantSettingsResponse['listPointOfSell']['pointOfSell']['label'])){
			// only 1 active point of sell
			$aPointOfSell = $getMerchantSettingsResponse['listPointOfSell']['pointOfSell'];
			$this->addPOSFromArray($aPointOfSell, 0);
		}else{ // more than 1 active point of sell
			$index = 0;
			foreach ($getMerchantSettingsResponse['listPointOfSell']['pointOfSell'] as $oPointOfSell){
				if($this->addPOSFromObject($oPointOfSell, $index)){
					$index++; // no incrementation if pos was not added
				}
			}
		}
	}
	
	private function updatePosData($posChoice,$primary_contracts,$secondary_contracts){
		if($primary_contracts == null){
			$primary_contracts = array();
		}
		if($secondary_contracts == null){
			$secondary_contracts = array();
		}
		$strPrimaryContracts = null;
		$strSecondaryContracts = null;
	
		for($ipos=0, $nbpos=sizeof($this->posData) ; $ipos<$nbpos ; $ipos++){
			if(strcmp($this->posData[$ipos]['label'],$posChoice) == 0){
				$this->posData[$ipos]['used'] = 1;
				for($ictr=0, $nbctr=sizeof($this->posData[$ipos]['contracts']) ; $ictr<$nbctr ; $ictr++){
					if(in_array($this->posData[$ipos]['contracts'][$ictr]['contractNumber'],$primary_contracts)){
						$this->posData[$ipos]['contracts'][$ictr]['primary'] = 1;
						if($strPrimaryContracts == null){
							$strPrimaryContracts .= $this->posData[$ipos]['contracts'][$ictr]['contractNumber'];
						}else{
							$strPrimaryContracts .= ";".$this->posData[$ipos]['contracts'][$ictr]['contractNumber'];
						}
					}else{
						$this->posData[$ipos]['contracts'][$ictr]['primary'] = 0;
					}
					if(in_array($this->posData[$ipos]['contracts'][$ictr]['contractNumber'],$secondary_contracts)){
						$this->posData[$ipos]['contracts'][$ictr]['secondary'] = 1;
						if($strSecondaryContracts == null){
							$strSecondaryContracts .= $this->posData[$ipos]['contracts'][$ictr]['contractNumber'];
						}else{
							$strSecondaryContracts .= ";".$this->posData[$ipos]['contracts'][$ictr]['contractNumber'];
						}
					}else{
						$this->posData[$ipos]['contracts'][$ictr]['secondary'] = 0;
					}
				}
			}else{
				$this->posData[$ipos]['used'] = 0;
				for($ictr=0, $nbctr=sizeof($this->posData[$ipos]['contracts']) ; $ictr<$nbctr ; $ictr++){
					$this->posData[$ipos]['contracts'][$ictr]['primary'] = 0;
					$this->posData[$ipos]['contracts'][$ictr]['secondary'] = 0;
				}
			}
		}
	}
	
	private function getLogo($cardType){
		$imagePath = (DIR_SYSTEM.'payline/logos/');
		switch ($cardType) {
			case "PASS":
				return $imagePath."PASS.gif";
				break;
			case "COFINOGA":
				return $imagePath."COFINOGA.gif";
				break;
			case "CB":
				return $imagePath."p_logo_cb_visa_mastercard.gif";
				break;
			case "JCB":
				return $imagePath."JCB.gif";
				break;
			case "AMEX":
				return $imagePath."AMEX.gif";
				break;
			case "CBPASS":
				return $imagePath."CBPASS.gif";
				break;
			case "DINERS":
				return $imagePath."p_logo_diners.gif";
				break;
			case "PAYPAL":
				return $imagePath."p_logo_paypal.gif";
				break;
			case "MCVISA":
				return $imagePath."p_logo_visa_mastercard.gif";
				break;
			case "IDEAL":
				return $imagePath."ideal.gif";
				break;
			case "ELV":
				return $imagePath."p_logo_elv.gif";
				break;
			case "MAESTRO":
				return $imagePath."MAESTRO.gif";
				break;
			case "1EURO.COM":
				return $imagePath."p_logo_1euro.gif";
				break;
			case "PAYFAIR":
				return $imagePath."p_logo_payfair.jpg";
				break;
			case "MASTERCARDPASS":
				return $imagePath."MASTERCARD.gif";
				break;
			case "INTERNET+":
				return $imagePath."p_logo_internetplus.gif";
				break;
			case "PAYSAFECARD":
				return $imagePath."p_logo_paysafecard.png";
				break;
			case "SKRILL(MONEYBOOKERS)":
				return $imagePath."p_logo_skrill.gif";
				break;
			case "LEETCHI":
				return $imagePath."p_logo_leetchi.jpg";
				break;
			case "3XCB":
				return $imagePath."p_logo_3xcb.jpg";
				break;
			case "TICKETSURF":
				return $imagePath."p_logo_ticketsurf.png";
				break;
			case "BUYSTER":
				return $imagePath."p_logo_buyster.bmp";
				break;
			case "EMONEO":
				return $imagePath."p_logo_moneo.png";
				break;
			case "WEXPAY":
				return $imagePath."logo_wexpay.png";
				break;
			case "MAXICHEQUE":
				return $imagePath."p_logo_maxicheque.gif";
				break;
			case "FNAC":
				return $imagePath."p_logo_fnac.gif";
				break;
			case "PRINTEMPS":
				return $imagePath."PRINTEMPS.gif";
				break;
			case "SURCOUF":
				return $imagePath."SURCOUF.gif";
				break;
			case "KANGOUROU":
				return $imagePath."p_logo_kangourou.gif";
				break;
			case "VISA":
				return $imagePath."VISA.gif";
				break;
			case "MASTERCARD":
				return $imagePath."MASTERCARD.gif";
				break;
			case "AURORE":
				return $imagePath."p_logo_aurore.gif";
				break;
			case "CYRILLUS":
				return $imagePath."p_logo_cyrillus.gif";
				break;
			case "CDGP":
				return $imagePath."p_logo_cdgp.gif";
				break;
			case "MANDARINE":
				return $imagePath."p_logo_mandarine.gif";
				break;
			case "OKSHOPPING":
				return $imagePath."p_logo_okshopping.gif";
				break;
			case "CASINO":
				return $imagePath."p_logo_casino.gif";
				break;
			case "SWITCH":
				return $imagePath."p_logo_switch.gif";
				break;
			case "MAESTRO":
				return $imagePath."MAESTRO.gif";
				break;
			case "AMEX-REC BILLING":
				return $imagePath."p_logo_amex_rec.png";
				break;
			case "AMEX-ONE CLICK":
				return $imagePath."p_logo_amex_rec.png";
				break;
			case "NEOSURF":
				return $imagePath."p_logo_neosurf.png";
				break;
			default:
				return $imagePath."defaultLogo.png";
			break;
		}
	}
	
	/**
	* @method writeTrace
	* @desc write a trace in Payline log file
	* @param $trace : the string to add in the log file
	*/
	private function writeTrace($trace){
		if(!isset($this->paylineTrace)){
			$this->paylineTrace = new Log('payline_'.date('Y-m-d',time()).'.txt');
		}
		$this->paylineTrace->write($trace);
	}
	
	/**
	 * @method validate
	 * @desc checks the values posted by the Payline configuration form
	 */
	private function validate() {
		
		$exit = false;
		
		if (!$this->user->hasPermission('modify', 'payment/payline')) {
			$this->writeTrace("[ADMIN] - current user has no permission to edit configuration");
			$this->error['warning'] = $this->language->get('error_permission');
			$exit = true;
		}
		if (!$this->request->post['payline_method_name']) {
			$this->writeTrace("[ADMIN] - Payline method name is missing");
			$this->error['warning'] = $this->language->get('error_config');
			$this->error['method_name'] = $this->language->get('required_method_name');
			$exit = true;
		}
		if (!$this->request->post['payline_merchant_id']) {
			$this->writeTrace("[ADMIN] - Payline merchant ID is missing");
			$this->error['warning'] = $this->language->get('error_config');
			$this->error['merchant_id'] = $this->language->get('required_merchant_id');
			$exit = true;
		}
		if (!$this->request->post['payline_access_key']) {
			$this->writeTrace("[ADMIN] - Payline access key is missing");
			$this->error['warning'] = $this->language->get('error_config');
			$this->error['access_key'] = $this->language->get('required_access_key');
			$exit = true;
		}
		
		if ($exit) {
			return false;
		}
		$exit = false; // reset exit flag
		
		/*
		 * A sample web service (getMerchantSettings) call is done to check the configuration
		 */
		$paylineSDK = new paylineSDK(
			$this->request->post['payline_merchant_id'],
			$this->request->post['payline_access_key'],
			$this->request->post['proxy_host'],
			$this->request->post['proxy_port'],
			$this->request->post['proxy_login'],
			$this->request->post['proxy_password'],
			$this->request->post['production']
		);	
		
		$getMerchantSettingsParams = array();
		$this->writeTrace("[ADMIN] - getMerchantSetting call... (merchant_id=".$this->request->post['payline_merchant_id'].", proxy_host=".$this->request->post['proxy_host'].", production=".$this->request->post['production'].")");
		$getMerchantSettingsResponse = $paylineSDK->getMerchantSettings($getMerchantSettingsParams);
		$this->request->post['payline_basicsettingsok'] = 0;
		
		if(isset($getMerchantSettingsResponse) && isset($getMerchantSettingsResponse['result']['code'])){
			$getMerchantSettingsResponseCode = $getMerchantSettingsResponse['result']['code'];
			if($getMerchantSettingsResponseCode != '00000'){
				$this->error['warning'] = $this->language->get('error_config');
				switch($getMerchantSettingResponseCode) {
					case "02303":
						$this->error['default_contract'] = $this->language->get('error_contract');
						$this->error['contract_list1'] = $this->language->get('error_contract');
						$this->error['contract_list2'] = $this->language->get('error_contract');
						break;
					case "02305":
						$this->error['warning'] .= "<br/>".$getMerchantSettingsResponse['result']['longMessage'];
						break;
					default :
						$this->error['warning'] .= "<br/>".$this->language->get('error_getMerchantSettings').$getMerchantSettingsResponseCode;
						break;
				}
				$this->writeTrace("[ADMIN] - Payline configuration is KO. getMerchantSetting response code = ".$getMerchantSettingsResponse['result']['code']);
			}else{
				$this->writeTrace("[ADMIN] - Payline configuration is OK (successfull getMerchantSetting call)");
				$this->request->post['payline_basicsettingsok'] = 1;
				$this->merchantSettingsToPosData($getMerchantSettingsResponse);
				$paylinePosChoice = "";
				if(isset($this->request->post['paylinePosChoice'])){
					$paylinePosChoice = $this->request->post['paylinePosChoice'];
				}
				$primary_contracts = null;
				if(isset($this->request->post['payline_primary_contracts'])){
					$primary_contracts = $this->request->post['payline_primary_contracts'];
				}
				$secondary_contracts = null;
				if(isset($this->request->post['payline_secondary_contracts'])){
					$secondary_contracts = $this->request->post['payline_secondary_contracts'];
				}
				$this->updatePosData(
					$paylinePosChoice,
					$primary_contracts,
					$secondary_contracts
				);
				$this->request->post['payline_posData'] = $this->posData;
			}
		}else{
			$exit = true;
			$this->writeTrace("[ADMIN] - Payline configuration is KO. Unable to call getMerchantSetting : ".$getMerchantSettingsResponse);
			$this->error['warning'] = $this->language->get('error_config');
			$this->error['warning'] .= "<br/>".$this->language->get('error_connect')." : $getMerchantSettingsResponse";
			switch($getMerchantSettingsResponse) {
				case "Authorization Required":
					$this->error['environment'] = $this->language->get('error_credentials');
					$this->error['merchant_id'] = $this->language->get('error_credentials');
					$this->error['access_key'] = $this->language->get('error_credentials');
					break;
				case "Could not connect to host":
					$this->error['proxy'] = $this->language->get('error_proxy');
					break;
				case "02305":
					$this->error['warning'] .= "<br/>".$getMerchantSettingsResponse['result']['longMessage'];
					break;
			}
		}
		if (!$exit) {
			return true;
		} else {
			return false;
		}
	}
}
?>